/*
 Ŀ
                   PCX reading Module for 256 color images                  
                                Copyright KUMM 1997                         
                                    Ver 0.00                                
 
*/

#include <io.h>
#include <fcntl.H>
#include <malloc.h>

#define BCKG  0              //background

int readpcx(char *filename,char *screen,char *pal, int scrx, int scry);

typedef struct
{
 char sign[4];  //0a 05 01 08
 char unkonwn[4];
 short x;
 short y;
} HEADER;

HEADER *header;

//decompress the pcx image
void decompress(char *pic,char *screen)
{
 int scp=0,ism=0;

 while(scp<(header->x+1) *(header->y+1))
 {
  if((*pic & 128) && (*pic & 64))
  {
   ism=*pic&63;
   pic++;
   while(ism)
   {
    screen[scp]=*pic;
    scp++;
    ism--;
   }
  } else
  {
   screen[scp]=*pic;
   scp++;
  }
  pic++;
 }
}

// align to screen sized by x,y
// return :
// 1=OK
// 0=SHIT
int put(char *screen, int x, int y)
{
 int n;
 char *line;

 if(y<header->y+1 || x<header->x+1) return(0);  //nem fer a kepernyore

 if(x!=header->x+1)                              //pont jo
 {
  line=(char *) malloc(x); for(n=0;n<x;n++) line[n]=BCKG;
  for(n=header->y;n>-1;n--)
  {
   memcpy(line,screen+n*(header->x+1),header->x);
   memcpy(screen+n*x,line,x);
  }
  for(n=0;n<(y-(header->y))*x+x;n++) screen[header->y*x-x+n]=BCKG;
 }
 return(1);
}

//read and decomp the pcx image from filename to screen
//return:
//  1: OK
//  0: Picture is too big for the screen
// -1: not enough memory
// -2: can't open file
int readpcx(char *filename,char *screen,char *pal, int screenx, int screeny)
{
 int handle,n;
 char *pic,*picpal;
 int filesize;

 if ((handle=open(filename, O_RDONLY))==0) return(-2);
 if ((pic=(char*) malloc(filesize=filelength(handle)))==NULL)
 {
  close(handle);
  return(-1);
 }

 read(handle, pic,filesize);
 close(handle);

 (char *)header=(char *)pic;
 decompress(pic+128,screen);
 picpal=pic+filesize-768;
 if (pal)
 {
  for(n=0;n<768;n++)
  {
   pal[n]=picpal[n] >> 2;
  }
 }
 n=put(screen, screenx, screeny);
 free(pic);
 return(n);
}

