#include <my\mytypes.h>


typedef struct
{
        char            Signature[4];
        UWORD           Version;
        UWORD           OEMNameOffset;
        UWORD           OEMNameSegment;                 //Pointer to OEM name?
        UBYTE           Capabilities[4];
        UWORD           SupportedModesOffset;
        UWORD           SupportedModesSegment;          //Pointer to list of supported VESA and OEM modes (terminated with 0xffff).
        UBYTE           Reserved[238];
} VesaInfo;

typedef struct
{
        UWORD           ModeAttributes;
        UBYTE           WindowAAttributes;
        UBYTE           WindowBAttributes;
        UWORD           WindowGranularity;
        UWORD           WindowSize;
        UWORD           StartSegmentWindowA;
        UWORD           StartSegmentWindowB;
        void            (*WindowPositioningFunction)(DWORD page);
        UWORD           BytesPerScanLine;

        //Remainder of this structure is optional for VESA modes in v1.0/1.1, needed for OEM modes.

        UWORD           PixelWidth;
        UWORD           PixelHeight;
        UBYTE           CharacterCellPixelWidth;
        UBYTE           CharacterCellPixelHeight;
        UBYTE           NumberOfMemoryPlanes;
        UBYTE           BitsPerPixel;
        UBYTE           NumberOfBanks;
        UBYTE           MemoryModelType;
        UBYTE           SizeOfBank;
        UBYTE           NumberOfImagePages;
        UBYTE           Reserved1;

        //VBE v1.2+

        UBYTE           RedMaskSize;
        UBYTE           RedFieldPosition;
        UBYTE           GreenMaskSize;
        UBYTE           GreenFieldPosition;
        UBYTE           BlueMaskSize;
        UBYTE           BlueFieldPosition;
        UBYTE           ReservedMaskSize;
        UBYTE           ReservedFieldPosition;
        UBYTE           DirectColourModeInfo;

    //VBE v2.0+

    DWORD       PhysicalAddress;
    UBYTE       Reserved2[212];
} VesaModeData;

void GetVgaInfo(VesaInfo far *block);
void GetModeInfo(VesaModeData far *block, int mode);
